local M = {}

local cooldown = 0
local nextToggleTime = math.random(30, 90)
local snowActive = false

local function onUpdate(dt)
  cooldown = cooldown + dt
  if cooldown < nextToggleTime then return end
  cooldown = 0
  nextToggleTime = math.random(30, 90)

  local snow = scenetree.findObject("rain_coverage") or scenetree.findObject("WCA_rain") or scenetree.findObject("rain_single_drops")
  if not snow then
    log("E", "dynamicSnow", "No snow object found in the scene.")
    return
  end

  if not snowActive then
    local flakes = math.random(30000, 40000)
    snow:setField("dataBlock", 0, "Snow_menu")
	snow:setField("numDrops", 0, flakes)
    snow:postApply()

    snowActive = true
    log("I", "dynamicSnow", "Snow started with " .. flakes .. " flakes")
  else
    snow:setField("numDrops", 0, 0)
    snow:postApply()

	snowActive = false
    log("I", "dynamicSnow", "Snow stopped")
  end
end

M.onUpdate = onUpdate
return M
